"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const container_1 = __importDefault(require("../../container"));
const exchangeInfo_controller_1 = require("./v3/exchangeInfo.controller");
const order_controller_1 = require("./v3/order.controller");
const time_controller_1 = require("./v3/time.controller");
const userDataStream_controller_1 = require("./v3/userDataStream.controller");
const router = express_1.default.Router();
const timeController = container_1.default.resolve(time_controller_1.TimeController);
const orderController = container_1.default.resolve(order_controller_1.OrderController);
const userDataStreamController = container_1.default.resolve(userDataStream_controller_1.UserDataStreamController);
const exchangeInfoController = container_1.default.resolve(exchangeInfo_controller_1.ExchangeInfoController);
router.get('/v3/exchangeInfo', exchangeInfoController.getExchangeInfo.bind(exchangeInfoController));
router.post('/v3/userDataStream', userDataStreamController.postUserDataStream.bind(userDataStreamController));
router.put('/v3/userDataStream', userDataStreamController.putUserDataStream.bind(userDataStreamController));
router.delete('/v3/userDataStream', userDataStreamController.deleteUserDataStream.bind(userDataStreamController));
router.get('/v3/time', timeController.getTime.bind(timeController));
router.post('/v3/order', orderController.postOrder.bind(orderController));
exports.default = router;
