"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExchangeInfoController = void 0;
const binance_api_node_1 = __importDefault(require("binance-api-node"));
const fs_1 = require("fs");
const inversify_1 = require("inversify");
const path = __importStar(require("path"));
const configuration_service_1 = require("../../../services/configuration.service");
const exchangeInfo_store_1 = require("../../../store/exchangeInfo.store");
let ExchangeInfoController = class ExchangeInfoController {
    constructor(exchangeInfoStore, config) {
        this.exchangeInfoStore = exchangeInfoStore;
        this.config = config;
    }
    async getExchangeInfo(req, res) {
        if (this.config.get('localExchangeInfo')) {
            const filepath = path.join(__dirname, './../../../data/exchangeInfo.data.json');
            const result = JSON.parse(await fs_1.promises.readFile(filepath, 'utf8'));
            this.exchangeInfoStore.upsertMany(result.symbols);
            return res
                .header('Content-Type', 'application/json')
                .header('X-Local', 'true')
                .json(result);
        }
        else {
            const result = await (0, binance_api_node_1.default)().exchangeInfo();
            this.exchangeInfoStore.upsertMany(result.symbols);
            return res.header('X-Local', 'false').json(result);
        }
    }
};
ExchangeInfoController = __decorate([
    (0, inversify_1.injectable)(),
    __param(0, (0, inversify_1.inject)(exchangeInfo_store_1.ExchangeInfoStore)),
    __param(1, (0, inversify_1.inject)(configuration_service_1.ConfigurationService)),
    __metadata("design:paramtypes", [exchangeInfo_store_1.ExchangeInfoStore,
        configuration_service_1.ConfigurationService])
], ExchangeInfoController);
exports.ExchangeInfoController = ExchangeInfoController;
