import { NewOrderSpot, Order } from 'binance-api-node';
import { Request, Response } from 'express';
import { Controller } from '../../../controller';
import { OrderService } from '../../../services/order.service';
export declare enum OrderResponseType {
    ACK = "ACK",
    FULL = "FULL",
    RESULT = "RESULT"
}
export declare class OrderController implements Controller<'postOrder'> {
    private readonly orderService;
    constructor(orderService: OrderService);
    determineResponseType(data: NewOrderSpot): OrderResponseType;
    getACKResponse(data: Order): {
        transactTime?: number | undefined;
        symbol: string;
        orderId: number;
        orderListId: number;
        clientOrderId: string;
    };
    getRESULTResponse(data: Order): {
        price: string;
        origQty: string;
        executedQty: string;
        cummulativeQuoteQty: string;
        status: import("binance-api-node").OrderStatus_LT;
        timeInForce: import("binance-api-node").TimeInForce_LT;
        type: import("binance-api-node").OrderType_LT;
        side: import("binance-api-node").OrderSide_LT;
        transactTime?: number | undefined;
        symbol: string;
        orderId: number;
        orderListId: number;
        clientOrderId: string;
    };
    getFULLResponse(data: Order): {
        fills: import("binance-api-node").OrderFill[];
        price: string;
        origQty: string;
        executedQty: string;
        cummulativeQuoteQty: string;
        status: import("binance-api-node").OrderStatus_LT;
        timeInForce: import("binance-api-node").TimeInForce_LT;
        type: import("binance-api-node").OrderType_LT;
        side: import("binance-api-node").OrderSide_LT;
        transactTime?: number | undefined;
        symbol: string;
        orderId: number;
        orderListId: number;
        clientOrderId: string;
    };
    postOrder(req: Request, res: Response): Promise<Response<any, Record<string, any>>>;
}
