"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugController = void 0;
const akita_1 = require("@datorama/akita");
const inversify_1 = require("inversify");
const order_query_1 = require("../../store/order.query");
const userData_query_1 = require("../../store/userData.query");
let DebugController = class DebugController {
    constructor(orderQuery, userDataQuery) {
        this.orderQuery = orderQuery;
        this.userDataQuery = userDataQuery;
    }
    async getDebugInfo(req, res) {
        return res
            .header('X-Local', 'true')
            .json({
            orders: this.orderQuery.getValue(),
            userData: this.userDataQuery.getValue()
        });
    }
    async postReset(req, res) {
        (0, akita_1.resetStores)();
        return res
            .header('X-Local', 'true')
            .json({});
    }
};
DebugController = __decorate([
    (0, inversify_1.injectable)(),
    __param(0, (0, inversify_1.inject)(order_query_1.OrderQuery)),
    __param(1, (0, inversify_1.inject)(userData_query_1.UserDataQuery)),
    __metadata("design:paramtypes", [order_query_1.OrderQuery,
        userData_query_1.UserDataQuery])
], DebugController);
exports.DebugController = DebugController;
