"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const container_1 = __importDefault(require("../../container"));
const config_controller_1 = require("./config.controller");
const debug_controller_1 = require("./debug.controller");
const match_controller_1 = require("./match.controller");
const router = express_1.default.Router();
const configController = container_1.default.resolve(config_controller_1.ConfigController);
const debugController = container_1.default.resolve(debug_controller_1.DebugController);
const matchController = container_1.default.resolve(match_controller_1.MatchController);
router.get('/debug', debugController.getDebugInfo.bind(debugController));
router.post('/debug/reset', debugController.postReset.bind(debugController));
router.get('/config', configController.getConfig.bind(configController));
router.post('/match', matchController.postMatch.bind(matchController));
exports.default = router;
