/// <reference types="node" />
import http from 'http';
import WebSocket from 'ws';
import { BinanceService } from '../../../services/binance.service';
import { OrderMatchingService } from '../../../services/orderMatching.service';
import { WebsocketEventHandler } from '../websocketEventHandler';
export declare class KlineEventHandler implements WebsocketEventHandler {
    private readonly binanceService;
    private readonly orderMatchingService;
    constructor(binanceService: BinanceService, orderMatchingService: OrderMatchingService);
    shouldHandle(request: http.IncomingMessage): boolean;
    getPairFromStream(streamName: string): string;
    getPeriodFromStream(streamName: string): string;
    onMessage(connection: WebSocket, request: http.IncomingMessage): Promise<void>;
}
