"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KlineEventHandler = void 0;
const inversify_1 = require("inversify");
const binance_service_1 = require("../../../services/binance.service");
const orderMatching_service_1 = require("../../../services/orderMatching.service");
let KlineEventHandler = class KlineEventHandler {
    constructor(binanceService, orderMatchingService) {
        this.binanceService = binanceService;
        this.orderMatchingService = orderMatchingService;
    }
    shouldHandle(request) {
        var _a;
        return !!((_a = request.url) === null || _a === void 0 ? void 0 : _a.includes('@kline'));
    }
    getPairFromStream(streamName) {
        return streamName.split('@')[0].replace('/', '').toUpperCase();
    }
    getPeriodFromStream(streamName) {
        return streamName.split('@')[1].replace('kline_', '').toLowerCase();
    }
    async onMessage(connection, request) {
        const streamName = request === null || request === void 0 ? void 0 : request.url;
        if (!streamName)
            throw new Error(`Invalid stream name: ${streamName}`);
        const pair = this.getPairFromStream(streamName);
        const period = this.getPeriodFromStream(streamName);
        const candleCallback = (kline) => {
            connection.send(JSON.stringify(kline));
            this.orderMatchingService.matchWithPrice(pair, parseFloat(kline.k.c));
        };
        this.binanceService.getWsCandles(pair, period, candleCallback, false);
    }
};
KlineEventHandler = __decorate([
    (0, inversify_1.injectable)(),
    __param(0, (0, inversify_1.inject)(binance_service_1.BinanceService)),
    __param(1, (0, inversify_1.inject)(orderMatching_service_1.OrderMatchingService)),
    __metadata("design:paramtypes", [binance_service_1.BinanceService,
        orderMatching_service_1.OrderMatchingService])
], KlineEventHandler);
exports.KlineEventHandler = KlineEventHandler;
