/// <reference types="node" />
import http from 'http';
import WebSocket from 'ws';
import { ExchangeInfoService } from '../../../services/exchangeInfo.service';
import { OrderQuery } from '../../../store/order.query';
import { UserDataQuery } from '../../../store/userData.query';
import { WebsocketEventHandler } from '../websocketEventHandler';
export declare class UserDataStreamEventHandler implements WebsocketEventHandler {
    private readonly exchangeInfoService;
    private readonly userDataQuery;
    private readonly orderQuery;
    private connection?;
    private readonly filledOrderUpdates$;
    private readonly orderUpdateWithSymbol$;
    constructor(exchangeInfoService: ExchangeInfoService, userDataQuery: UserDataQuery, orderQuery: OrderQuery);
    shouldHandle(request: http.IncomingMessage): boolean;
    onMessage(connection: WebSocket, request: http.IncomingMessage): Promise<void>;
    private createExecutionReports;
}
