"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_1 = __importDefault(require("http"));
const inversify_1 = require("inversify");
const ws_1 = __importDefault(require("ws"));
const websocketEventHandler_1 = require("./websocketEventHandler");
let WebsocketServer = class WebsocketServer {
    constructor(eventHandlers) {
        this.eventHandlers = eventHandlers;
        this.wsServer = new ws_1.default.Server({
            noServer: true,
        });
        this.wsServer.on('connection', this.handleEvent.bind(this));
    }
    handleEvent(connection, request) {
        const remainingHandlers = this.eventHandlers.filter(handler => handler.shouldHandle(request));
        if (remainingHandlers.length <= 0) {
            throw new Error(`No handlers found for ${request === null || request === void 0 ? void 0 : request.url}`);
        }
        remainingHandlers.forEach(handler => handler.onMessage(connection, request));
    }
    createFromExpressApp(app) {
        const server = http_1.default.createServer(app);
        server.on('upgrade', (request, socket, head) => {
            this.wsServer.handleUpgrade(request, socket, head, (websocket) => {
                this.wsServer.emit('connection', websocket, request);
            });
        });
        return server;
    }
};
WebsocketServer = __decorate([
    (0, inversify_1.injectable)(),
    __param(0, (0, inversify_1.multiInject)(websocketEventHandler_1.WEBSOCKET_EVENT_HANDLER)),
    __metadata("design:paramtypes", [Array])
], WebsocketServer);
exports.default = WebsocketServer;
