"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var BinanceService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinanceService = void 0;
const binance_api_node_1 = __importDefault(require("binance-api-node"));
const inversify_1 = require("inversify");
let BinanceService = BinanceService_1 = class BinanceService {
    constructor() {
        this._client = (0, binance_api_node_1.default)();
        this._lastPrice = {};
    }
    getWsCandles(pair, period, cb, transform = true) {
        //@ts-ignore
        return this._client.ws.candles(pair, period, cb, transform);
    }
    async getCurrentPrice(symbol) {
        try {
            const now = Math.round(new Date().getTime());
            if (!this._lastPrice[symbol] || (now - this._lastPrice[symbol].time) > BinanceService_1.PRICE_CACHE_TIME) {
                const prices = await this._client.prices({ symbol });
                this._lastPrice[symbol] = {
                    time: now,
                    price: parseFloat(prices[symbol])
                };
            }
            return this._lastPrice[symbol].price;
        }
        catch (e) {
            throw new Error(`Unable to determine price for symbol "${symbol}"`);
        }
    }
};
BinanceService.PRICE_CACHE_TIME = 1000 * 60;
BinanceService = BinanceService_1 = __decorate([
    (0, inversify_1.injectable)()
], BinanceService);
exports.BinanceService = BinanceService;
