import { NewOrderSpot, Order } from 'binance-api-node';
import { Observable } from 'rxjs';
import { OrderQuery } from '../store/order.query';
import { OrderStore } from '../store/order.store';
import { ExchangeInfoService } from './exchangeInfo.service';
import { OrderMatchingService } from './orderMatching.service';
export declare class OrderService {
    private orderStore;
    private orderQuery;
    private orderMatchingService;
    private exchangeInfoService;
    constructor(orderStore: OrderStore, orderQuery: OrderQuery, orderMatchingService: OrderMatchingService, exchangeInfoService: ExchangeInfoService);
    addFromSpotOrder(order: NewOrderSpot): Promise<string>;
    /**
     * Get all orders 'confirmed' orders that are newly stored in the Order store.
     * @param {NewOrderSpot} order
     * @param {string} clientOrderId
     * @returns {Observable<Order>}
     */
    getConfirmedOrder$(order: NewOrderSpot, clientOrderId: string): Observable<Order>;
    private _formatInternalOrder;
    private _getBaseOrder;
    private _getLimitOrder;
    private _getMarketOrderQuote;
    private _getMarketOrderBase;
}
