import { Symbol } from 'binance-api-node';
import { ConfigurationService } from '../configuration.service';
import { InternalOrder, InternalOrderFill } from '../../store/order.interfaces';
import { OrderStore } from '../../store/order.store';
export declare abstract class BaseOrderMatcher {
    protected orderStore: OrderStore;
    private readonly config;
    constructor(orderStore: OrderStore, config: ConfigurationService);
    abstract shouldMatch(order: InternalOrder): boolean;
    abstract match(symbol: Symbol, order: InternalOrder, price: number): void;
    protected _createFills(order: InternalOrder, price: number, symbol: Symbol, amount?: number): InternalOrderFill[] | undefined;
}
