"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseOrderMatcher = void 0;
const inversify_1 = require("inversify");
const configuration_service_1 = require("../configuration.service");
const order_store_1 = require("../../store/order.store");
const internalOrder_utils_1 = require("../../utils/internalOrder.utils");
let BaseOrderMatcher = class BaseOrderMatcher {
    constructor(orderStore, config) {
        this.orderStore = orderStore;
        this.config = config;
    }
    _createFills(order, price, symbol, amount = 1) {
        const quantity = (0, internalOrder_utils_1.getBaseQuantity)(order, price);
        const commission = order.type === 'MARKET'
            ? this.config.get('feeTaker')
            : this.config.get('feeMaker');
        let fills = [];
        for (let i = 0; i < amount; i++) {
            const individualTradeQty = quantity / amount;
            const fee = order.side === 'BUY'
                ? individualTradeQty * commission
                : individualTradeQty * (commission * price);
            fills.push({
                tradeId: this.orderStore.getNewTradeId(),
                price: price,
                qty: individualTradeQty,
                commissionAsset: order.side === 'BUY' ? symbol.baseAsset : symbol.quoteAsset,
                commission: fee
            });
        }
        return fills;
    }
};
BaseOrderMatcher = __decorate([
    (0, inversify_1.injectable)(),
    __param(0, (0, inversify_1.inject)(order_store_1.OrderStore)),
    __param(1, (0, inversify_1.inject)(configuration_service_1.ConfigurationService)),
    __metadata("design:paramtypes", [order_store_1.OrderStore,
        configuration_service_1.ConfigurationService])
], BaseOrderMatcher);
exports.BaseOrderMatcher = BaseOrderMatcher;
