"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LimitOrderMatcher = void 0;
const inversify_1 = require("inversify");
const baseOrderMatcher_1 = require("./baseOrderMatcher");
let LimitOrderMatcher = class LimitOrderMatcher extends baseOrderMatcher_1.BaseOrderMatcher {
    shouldMatch(order) {
        return order.type === 'LIMIT';
    }
    match(symbol, order, price) {
        if (order.side === 'BUY' && price > order.price)
            return;
        if (order.side === 'SELL' && price < order.price)
            return;
        this.orderStore.update(order.clientOrderId, {
            price: order.price,
            origQty: order.origQty,
            executedQty: order.origQty,
            transactTime: new Date().getTime(),
            cummulativeQuoteQty: order.origQty * order.price,
            status: 'FILLED',
            fills: this._createFills(order, order.price, symbol, 1),
        });
    }
};
LimitOrderMatcher = __decorate([
    (0, inversify_1.injectable)()
], LimitOrderMatcher);
exports.LimitOrderMatcher = LimitOrderMatcher;
