"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarketOrderMatcher = void 0;
const inversify_1 = require("inversify");
const internalOrder_utils_1 = require("../../utils/internalOrder.utils");
const baseOrderMatcher_1 = require("./baseOrderMatcher");
let MarketOrderMatcher = class MarketOrderMatcher extends baseOrderMatcher_1.BaseOrderMatcher {
    shouldMatch(order) {
        return order.type === 'MARKET';
    }
    match(symbol, order, price) {
        const quantity = (0, internalOrder_utils_1.getBaseQuantity)(order, price);
        const executedQuantity = quantity;
        const cumQuoteQuantity = (0, internalOrder_utils_1.getQuoteQuantity)(order, price);
        this.orderStore.update(order.clientOrderId, {
            price: price,
            origQty: quantity,
            executedQty: executedQuantity,
            cummulativeQuoteQty: cumQuoteQuantity,
            status: 'FILLED',
            fills: this._createFills(order, price, symbol, 1),
        });
    }
};
MarketOrderMatcher = __decorate([
    (0, inversify_1.injectable)()
], MarketOrderMatcher);
exports.MarketOrderMatcher = MarketOrderMatcher;
