import { OrderQuery } from '../store/order.query';
import { BinanceService } from './binance.service';
import { ExchangeInfoService } from './exchangeInfo.service';
import { BaseOrderMatcher } from './orderMatchers/baseOrderMatcher';
export declare class OrderMatchingService {
    private binanceService;
    private orderQuery;
    private exchangeInfoService;
    private orderMatchers;
    constructor(binanceService: BinanceService, orderQuery: OrderQuery, exchangeInfoService: ExchangeInfoService, orderMatchers: BaseOrderMatcher[]);
    match(symbol: string, marketPrice: number): Promise<void>;
    matchWithPrice(symbol: string, closePrice: number): Promise<void>;
    matchWithMarketPrice(symbol: string): Promise<void>;
}
