import { QueryEntity } from '@datorama/akita';
import { Observable } from 'rxjs';
import { InternalFilledOrder, InternalOrder } from './order.interfaces';
import { OrderState, OrderStore } from './order.store';
export declare class OrderQuery extends QueryEntity<OrderState> {
    protected store: OrderStore;
    constructor(store: OrderStore);
    getOpenOrdersForSymbol$(symbol: string): Observable<InternalOrder[]>;
    /**
     * Emits a list of all filled orders
     * @returns {Observable<InternalFilledOrder[]>}
     */
    getFilledOrders$(): Observable<InternalFilledOrder[]>;
    /**
     * Emits a single order update by comparing prev and current emits
     * @returns {Observable<InternalFilledOrder>}
     */
    getFilledOrderUpdates$(): Observable<InternalFilledOrder>;
}
